=== modified file 'plugin/innobase/ibuf/ibuf0ibuf.cc'
--- plugin/innobase/ibuf/ibuf0ibuf.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/ibuf/ibuf0ibuf.cc	2010-12-26 03:15:44 +0000
@@ -516,7 +516,7 @@
 	page_t*		header_page;
 	ulint		error;
 
-	ibuf = mem_alloc(sizeof(ibuf_t));
+	ibuf = static_cast<ibuf_t *>(mem_alloc(sizeof(ibuf_t)));
 
 	memset(ibuf, 0, sizeof(*ibuf));
 
@@ -1794,7 +1794,7 @@
 
 	field = dtuple_get_nth_field(tuple, 0);
 
-	buf = mem_heap_alloc(heap, 4);
+	buf = static_cast<byte *>(mem_heap_alloc(heap, 4));
 
 	mach_write_to_4(buf, space);
 
@@ -1804,7 +1804,7 @@
 
 	field = dtuple_get_nth_field(tuple, 1);
 
-	buf = mem_heap_alloc(heap, 1);
+	buf = static_cast<byte *>(mem_heap_alloc(heap, 1));
 
 	/* We set the marker byte zero */
 
@@ -1816,7 +1816,7 @@
 
 	field = dtuple_get_nth_field(tuple, 2);
 
-	buf = mem_heap_alloc(heap, 4);
+	buf = static_cast<byte *>(mem_heap_alloc(heap, 4));
 
 	mach_write_to_4(buf, page_no);
 
@@ -1831,8 +1831,8 @@
 		i = IBUF_REC_INFO_SIZE;
 	}
 
-	ti = type_info = mem_heap_alloc(heap, i + n_fields
-					* DATA_NEW_ORDER_NULL_TYPE_BUF_SIZE);
+	ti = type_info = static_cast<byte *>(mem_heap_alloc(heap, i + n_fields
+					* DATA_NEW_ORDER_NULL_TYPE_BUF_SIZE));
 
 	switch (i) {
 	default:
@@ -1935,7 +1935,7 @@
 
 	field = dtuple_get_nth_field(tuple, 0);
 
-	buf = mem_heap_alloc(heap, 4);
+	buf = static_cast<byte *>(mem_heap_alloc(heap, 4));
 
 	mach_write_to_4(buf, page_no);
 
@@ -1970,7 +1970,7 @@
 
 	field = dtuple_get_nth_field(tuple, 0);
 
-	buf = mem_heap_alloc(heap, 4);
+	buf = static_cast<byte *>(mem_heap_alloc(heap, 4));
 
 	mach_write_to_4(buf, space);
 
@@ -1980,7 +1980,7 @@
 
 	field = dtuple_get_nth_field(tuple, 1);
 
-	buf = mem_heap_alloc(heap, 1);
+	buf = static_cast<byte *>(mem_heap_alloc(heap, 1));
 
 	mach_write_to_1(buf, 0);
 
@@ -1990,7 +1990,7 @@
 
 	field = dtuple_get_nth_field(tuple, 2);
 
-	buf = mem_heap_alloc(heap, 4);
+	buf = static_cast<byte *>(mem_heap_alloc(heap, 4));
 
 	mach_write_to_4(buf, page_no);
 
@@ -3272,7 +3272,7 @@
 
 	/* Patch counter value in already built entry. */
 	field = dtuple_get_nth_field(entry, 3);
-	data = dfield_get_data(field);
+	data = static_cast<byte *>(dfield_get_data(field));
 
 	mach_write_to_2(data + IBUF_REC_OFFSET_COUNTER, counter);
 

=== modified file 'plugin/innobase/lock/lock0lock.cc'
--- plugin/innobase/lock/lock0lock.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/lock/lock0lock.cc	2010-12-26 03:15:44 +0000
@@ -566,7 +566,7 @@
 /*============*/
 	ulint	n_cells)	/*!< in: number of slots in lock hash table */
 {
-	lock_sys = mem_alloc(sizeof(lock_sys_t));
+	lock_sys = static_cast<lock_sys_t *>(mem_alloc(sizeof(lock_sys_t)));
 
 	lock_sys->rec_hash = hash_create(n_cells);
 
@@ -615,7 +615,7 @@
 {
 	ut_ad(lock);
 
-	return(lock->type_mode & LOCK_MODE_MASK);
+	return static_cast<lock_mode>(lock->type_mode & LOCK_MODE_MASK);
 }
 
 /*********************************************************************//**
@@ -918,7 +918,7 @@
 	ut_ad(lock_get_type_low(lock2) == LOCK_REC);
 
 	if (trx != lock2->trx
-	    && !lock_mode_compatible(LOCK_MODE_MASK & type_mode,
+	    && !lock_mode_compatible(static_cast<lock_mode>(LOCK_MODE_MASK & type_mode),
 				     lock_get_mode(lock2))) {
 
 		/* We have somewhat complex rules when gap type record locks
@@ -1113,7 +1113,7 @@
 	page_no = lock->un_member.rec_lock.page_no;
 
 	for (;;) {
-		lock = HASH_GET_NEXT(hash, lock);
+		lock = static_cast<lock_t *>(HASH_GET_NEXT(hash, lock));
 
 		if (!lock) {
 
@@ -1145,8 +1145,8 @@
 
 	ut_ad(mutex_own(&kernel_mutex));
 
-	lock = HASH_GET_FIRST(lock_sys->rec_hash,
-			      lock_rec_hash(space, page_no));
+	lock = static_cast<lock_t *>(HASH_GET_FIRST(lock_sys->rec_hash,
+			      lock_rec_hash(space, page_no)));
 	while (lock) {
 		if ((lock->un_member.rec_lock.space == space)
 		    && (lock->un_member.rec_lock.page_no == page_no)) {
@@ -1154,7 +1154,7 @@
 			break;
 		}
 
-		lock = HASH_GET_NEXT(hash, lock);
+		lock = static_cast<lock_t *>(HASH_GET_NEXT(hash, lock));
 	}
 
 	return(lock);
@@ -1204,7 +1204,7 @@
 
 	hash = buf_block_get_lock_hash_val(block);
 
-	lock = HASH_GET_FIRST(lock_sys->rec_hash, hash);
+	lock = static_cast<lock_t *>(HASH_GET_FIRST(lock_sys->rec_hash, hash));
 
 	while (lock) {
 		if ((lock->un_member.rec_lock.space == space)
@@ -1213,7 +1213,7 @@
 			break;
 		}
 
-		lock = HASH_GET_NEXT(hash, lock);
+		lock = static_cast<lock_t *>(HASH_GET_NEXT(hash, lock));
 	}
 
 	return(lock);
@@ -1303,7 +1303,7 @@
 
 	size = sizeof(lock_t) + lock_rec_get_n_bits(lock) / 8;
 
-	return(mem_heap_dup(heap, lock, size));
+	return static_cast<lock_t>(mem_heap_dup(heap, lock, size));
 }
 
 /*********************************************************************//**
@@ -1694,7 +1694,7 @@
 	n_bits = page_dir_get_n_heap(page) + LOCK_PAGE_BITMAP_MARGIN;
 	n_bytes = 1 + n_bits / 8;
 
-	lock = mem_heap_alloc(trx->lock_heap, sizeof(lock_t) + n_bytes);
+	lock = static_cast<lock_t *>(mem_heap_alloc(trx->lock_heap, sizeof(lock_t) + n_bytes));
 
 	UT_LIST_ADD_LAST(trx_locks, trx->trx_locks, lock);
 
@@ -2050,7 +2050,7 @@
 		/* The trx already has a strong enough lock on rec: do
 		nothing */
 
-	} else if (lock_rec_other_has_conflicting(mode, block, heap_no, trx)) {
+	} else if (lock_rec_other_has_conflicting(static_cast<lock_mode>(mode), block, heap_no, trx)) {
 
 		/* If another transaction has a non-gap conflicting request in
 		the queue, as this transaction does not have a lock strong
@@ -3656,7 +3656,7 @@
 		    && !ib_vector_is_empty(trx->autoinc_locks)) {
 			lock_t*	autoinc_lock;
 
-			autoinc_lock = ib_vector_pop(trx->autoinc_locks);
+			autoinc_lock = static_cast<lock_t>(ib_vector_pop(trx->autoinc_locks));
 			ut_a(autoinc_lock == lock);
 		}
 
@@ -5052,7 +5052,7 @@
 	on the successor, which produced an unnecessary deadlock. */
 
 	if (lock_rec_other_has_conflicting(
-		    LOCK_X | LOCK_GAP | LOCK_INSERT_INTENTION,
+		    static_cast<lock_mode>(LOCK_X | LOCK_GAP | LOCK_INSERT_INTENTION),
 		    block, next_rec_heap_no, trx)) {
 
 		/* Note that we may get DB_SUCCESS also here! */
@@ -5492,7 +5492,7 @@
 
 	/* The lock to be release must be the last lock acquired. */
 	last = ib_vector_size(autoinc_locks) - 1;
-	lock = ib_vector_get(autoinc_locks, last);
+	lock = static_cast<lock_t>(ib_vector_get(autoinc_locks, last));
 
 	/* Should have only AUTOINC locks in the vector. */
 	ut_a(lock_get_mode(lock) == LOCK_AUTO_INC);

=== modified file 'plugin/innobase/log/log0log.cc'
--- plugin/innobase/log/log0log.cc	2010-12-26 00:22:34 +0000
+++ plugin/innobase/log/log0log.cc	2010-12-26 03:15:44 +0000
@@ -926,12 +926,12 @@
 #endif /* UNIV_LOG_ARCHIVE */
 
 	for (i = 0; i < n_files; i++) {
-		group->file_header_bufs_ptr[i] = static_cast<mem_block_info_t *>(mem_alloc(
+		group->file_header_bufs_ptr[i] = static_cast<unsigned char *>(mem_alloc(
 			LOG_FILE_HDR_SIZE + OS_FILE_LOG_BLOCK_SIZE));
 
-		group->file_header_bufs[i] = ut_align(
+		group->file_header_bufs[i] = static_cast<unsigned char *>(ut_align(
 			group->file_header_bufs_ptr[i],
-			OS_FILE_LOG_BLOCK_SIZE);
+			OS_FILE_LOG_BLOCK_SIZE));
 
 		memset(*(group->file_header_bufs + i), '\0',
 		       LOG_FILE_HDR_SIZE);
@@ -957,8 +957,8 @@
 #endif /* UNIV_LOG_ARCHIVE */
 
 	group->checkpoint_buf_ptr = static_cast<unsigned char *>(mem_alloc(2 * OS_FILE_LOG_BLOCK_SIZE));
-	group->checkpoint_buf = ut_align(group->checkpoint_buf_ptr,
-					 OS_FILE_LOG_BLOCK_SIZE);
+	group->checkpoint_buf = static_cast<unsigned char*>(ut_align(group->checkpoint_buf_ptr,
+					 OS_FILE_LOG_BLOCK_SIZE));
 
 	memset(group->checkpoint_buf, '\0', OS_FILE_LOG_BLOCK_SIZE);
 

=== modified file 'plugin/innobase/log/log0recv.cc'
--- plugin/innobase/log/log0recv.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/log/log0recv.cc	2010-12-26 03:15:44 +0000
@@ -180,7 +180,7 @@
 		return;
 	}
 
-	recv_sys = mem_alloc(sizeof(*recv_sys));
+	recv_sys = static_cast<recv_sys_t *>(mem_alloc(sizeof(*recv_sys)));
 	memset(recv_sys, 0x0, sizeof(*recv_sys));
 
 	mutex_create(recv_sys_mutex_key, &recv_sys->mutex, SYNC_RECV);
@@ -327,7 +327,7 @@
 		recv_n_pool_free_frames = 512;
 	}
 
-	recv_sys->buf = ut_malloc(RECV_PARSING_BUF_SIZE);
+	recv_sys->buf = static_cast<byte *>(ut_malloc(RECV_PARSING_BUF_SIZE));
 	recv_sys->len = 0;
 	recv_sys->recovered_offset = 0;
 
@@ -337,10 +337,10 @@
 	recv_sys->apply_log_recs = FALSE;
 	recv_sys->apply_batch_on = FALSE;
 
-	recv_sys->last_block_buf_start = mem_alloc(2 * OS_FILE_LOG_BLOCK_SIZE);
+	recv_sys->last_block_buf_start = static_cast<byte *>(mem_alloc(2 * OS_FILE_LOG_BLOCK_SIZE));
 
-	recv_sys->last_block = ut_align(recv_sys->last_block_buf_start,
-					OS_FILE_LOG_BLOCK_SIZE);
+	recv_sys->last_block = static_cast<byte *>(ut_align(recv_sys->last_block_buf_start,
+					OS_FILE_LOG_BLOCK_SIZE));
 	recv_sys->found_corrupt_log = FALSE;
 
 	recv_max_page_lsn = 0;
@@ -1319,8 +1319,8 @@
 {
 	recv_addr_t*	recv_addr;
 
-	recv_addr = HASH_GET_FIRST(recv_sys->addr_hash,
-				   recv_hash(space, page_no));
+	recv_addr = static_cast<recv_addr_t *>(HASH_GET_FIRST(recv_sys->addr_hash,
+				   recv_hash(space, page_no)));
 	while (recv_addr) {
 		if ((recv_addr->space == space)
 		    && (recv_addr->page_no == page_no)) {
@@ -1328,7 +1328,7 @@
 			break;
 		}
 
-		recv_addr = HASH_GET_NEXT(addr_hash, recv_addr);
+		recv_addr = static_cast<recv_addr_t *>(HASH_GET_NEXT(addr_hash, recv_addr));
 	}
 
 	return(recv_addr);
@@ -1363,7 +1363,7 @@
 
 	len = rec_end - body;
 
-	recv = mem_heap_alloc(recv_sys->heap, sizeof(recv_t));
+	recv = static_cast<recv_t *>(mem_heap_alloc(recv_sys->heap, sizeof(recv_t)));
 	recv->type = type;
 	recv->len = rec_end - body;
 	recv->start_lsn = start_lsn;
@@ -1372,8 +1372,8 @@
 	recv_addr = recv_get_fil_addr_struct(space, page_no);
 
 	if (recv_addr == NULL) {
-		recv_addr = mem_heap_alloc(recv_sys->heap,
-					   sizeof(recv_addr_t));
+		recv_addr = static_cast<recv_addr_t *>(mem_heap_alloc(recv_sys->heap,
+					   sizeof(recv_addr_t)));
 		recv_addr->space = space;
 		recv_addr->page_no = page_no;
 		recv_addr->state = RECV_NOT_PROCESSED;
@@ -1405,8 +1405,8 @@
 			len = RECV_DATA_BLOCK_SIZE;
 		}
 
-		recv_data = mem_heap_alloc(recv_sys->heap,
-					   sizeof(recv_data_t) + len);
+		recv_data = static_cast<recv_addr_t>(mem_heap_alloc(recv_sys->heap,
+					   sizeof(recv_data_t) + len));
 		*prev_field = recv_data;
 
 		memcpy(recv_data + 1, body, len);
@@ -1568,7 +1568,7 @@
 			/* We have to copy the record body to a separate
 			buffer */
 
-			buf = mem_alloc(recv->len);
+			buf = static_cast<byte *>(mem_alloc(recv->len));
 
 			recv_data_copy_to_buf(buf, recv);
 		} else {
@@ -1767,7 +1767,7 @@
 
 	for (i = 0; i < hash_get_n_cells(recv_sys->addr_hash); i++) {
 
-		recv_addr = HASH_GET_FIRST(recv_sys->addr_hash, i);
+		recv_addr = static_cast<recv_addr_t *>(HASH_GET_FIRST(recv_sys->addr_hash, i));
 
 		while (recv_addr) {
 			ulint	space = recv_addr->space;
@@ -1808,7 +1808,7 @@
 				mutex_enter(&(recv_sys->mutex));
 			}
 
-			recv_addr = HASH_GET_NEXT(addr_hash, recv_addr);
+			recv_addr = static_cast<recv_addr_t *>(HASH_GET_NEXT(addr_hash, recv_addr));
 		}
 
 		if (has_printed

=== modified file 'plugin/innobase/page/page0cur.cc'
--- plugin/innobase/page/page0cur.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/page/page0cur.cc	2010-12-26 03:15:44 +0000
@@ -879,7 +879,7 @@
 	if (mismatch_index + end_seg_len < sizeof buf1) {
 		buf = buf1;
 	} else {
-		buf = mem_alloc(mismatch_index + end_seg_len);
+		buf = static_cast<byte *>(mem_alloc(mismatch_index + end_seg_len));
 	}
 
 	/* Build the inserted record to buf */

=== modified file 'plugin/innobase/page/page0page.cc'
--- plugin/innobase/page/page0page.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/page/page0page.cc	2010-12-26 03:15:44 +0000
@@ -2336,7 +2336,8 @@
 	/* The following buffer is used to check that the
 	records in the page record heap do not overlap */
 
-	buf = mem_heap_zalloc(heap, UNIV_PAGE_SIZE);
+        void *buf_ptr= mem_heap_zalloc(heap, UNIV_PAGE_SIZE);
+	buf = static_cast<byte *>(buf_ptr);
 
 	/* Check first that the record heap and the directory do not
 	overlap. */

